(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13869,        352]
NotebookOptionsPosition[     11654,        297]
NotebookOutlinePosition[     12010,        313]
CellTagsIndexPosition[     11967,        310]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Functions", "Chapter",
 CellChangeTimes->{{3.796838064122548*^9, 3.7968380652631063`*^9}},
 FontSize->18,
 CellID->2121923006,ExpressionUUID->"e17d54d9-b671-4f0f-a60e-b794acba23c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RenderModel1", "[", 
   RowBox[{"selectedFolder_", ",", "selectedImgName_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "fileNames", ",", "names", ",", "imgs", ",", "selectedImg", ",", 
      "imgOneAll", ",", "restImgs", ",", "imgMod", ",", "imgAll"}], "}"}], 
    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"fileNames", "=", 
      RowBox[{"FileNames", "[", 
       RowBox[{"\"\<*.JPEG\>\"", ",", 
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", "selectedFolder"}]}], 
       "]"}]}], ";", "\n", 
     RowBox[{"names", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"StringDelete", "[", 
         RowBox[{"#", ",", "\"\<.jpeg\>\""}], "]"}], "&"}], "/@", 
       RowBox[{"Last", "/@", 
        RowBox[{"FileNameSplit", "/@", "fileNames"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"imgs", "=", 
      RowBox[{"Association", "[", 
       RowBox[{"Thread", "[", 
        RowBox[{"names", "\[Rule]", " ", 
         RowBox[{"Import", "/@", "fileNames"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"selectedImg", "=", 
      RowBox[{"imgs", "[", "selectedImgName", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"restImgs", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"ImageResize", "[", 
         RowBox[{"#", ",", 
          RowBox[{"ImageDimensions", "[", "selectedImg", "]"}]}], "]"}], 
        "&"}], "/@", 
       RowBox[{"Values", "[", "imgs", "]"}]}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"imgOneAll", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"ImageAdd", "[", 
         RowBox[{
          RowBox[{"ImageMultiply", "[", 
           RowBox[{"selectedImg", ",", 
            RowBox[{"2", "/", "3"}]}], "]"}], ",", 
          RowBox[{"ImageMultiply", "[", 
           RowBox[{"#", ",", 
            RowBox[{"1", "/", "3"}]}], "]"}]}], "]"}], "&"}], "/@", 
       "restImgs"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"imgMod", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"ImageMultiply", "[", 
         RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", "restImgs"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"imgAll", "=", 
      RowBox[{"ImageAdjust", "[", 
       RowBox[{
        RowBox[{"ImageMultiply", "[", "imgMod", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0.5"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<imgs\>\"", "\[Rule]", " ", 
        RowBox[{"Values", "@", "imgs"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<imgOneAll\>\"", "\[Rule]", " ", "imgOneAll"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<imgAll\>\"", "\[Rule]", " ", "imgAll"}]}], 
      "\[IndentingNewLine]", "|>"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Code",
 CellChangeTimes->{{3.7968373985723143`*^9, 3.796837470749798*^9}, {
  3.796837514817059*^9, 3.796837553507622*^9}, {3.7968375871000013`*^9, 
  3.7968376605741034`*^9}, {3.7968376966538754`*^9, 3.796837779141247*^9}, {
  3.79683842140167*^9, 3.7968384214774323`*^9}, {3.7968384608446693`*^9, 
  3.79683846659024*^9}, {3.7968778784716597`*^9, 3.79687788376024*^9}},
 CellLabel->"In[12]:=",
 CellID->1720803360,ExpressionUUID->"30445314-8f63-4a39-ae4e-174de649c33b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RenderModel2", "[", 
   RowBox[{"selectedFolder_", ",", "background_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"fileNames", ",", "names", ",", "imgs"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"fileNames", "=", 
      RowBox[{"FileNames", "[", 
       RowBox[{"\"\<*.JPEG\>\"", ",", 
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", "selectedFolder"}]}], 
       "]"}]}], ";", "\n", 
     RowBox[{"names", "=", 
      RowBox[{"ToExpression", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"StringDelete", "[", 
          RowBox[{"#", ",", "\"\<.jpeg\>\""}], "]"}], "&"}], "/@", 
        RowBox[{"Last", "/@", 
         RowBox[{"FileNameSplit", "/@", "fileNames"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"imgs", "=", 
      RowBox[{"Thread", "[", 
       RowBox[{"names", "\[Rule]", " ", 
        RowBox[{"Import", "/@", "fileNames"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ImageCollage", "[", 
      RowBox[{"imgs", ",", 
       RowBox[{"Background", "\[Rule]", "background"}], ",", 
       RowBox[{"ImagePadding", "\[Rule]", "5"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Code",
 CellChangeTimes->{{3.796835317179235*^9, 3.796835546617688*^9}, {
   3.7968356147506866`*^9, 3.796835614910028*^9}, {3.796835666620388*^9, 
   3.796835687269145*^9}, {3.7968361579280033`*^9, 3.796836158915587*^9}, {
   3.796836202777413*^9, 3.7968362336737843`*^9}, {3.796836350192675*^9, 
   3.796836350546612*^9}, {3.796837823398168*^9, 3.796837907840406*^9}, {
   3.79683794651*^9, 3.7968379527852097`*^9}, 3.7968380218280687`*^9, {
   3.796878090861353*^9, 3.796878095700807*^9}, 3.796878162247119*^9},
 CellLabel->"In[26]:=",
 CellID->81939663,ExpressionUUID->"6cd1e4bf-555a-4b2b-b98d-5c5a2ea95c97"]
}, Closed]],

Cell[CellGroupData[{

Cell["Rendering your Model", "Title",
 CellChangeTimes->{{3.782368628849678*^9, 3.782368637064456*^9}, {
   3.782396007764318*^9, 3.7823960082879963`*^9}, 3.796878079435726*^9},
 CellID->323882155,ExpressionUUID->"6c329363-bbb7-4566-a37f-03d97126da56"],

Cell[CellGroupData[{

Cell["Code", "Chapter",
 CellChangeTimes->{{3.796838077290256*^9, 3.796838077784466*^9}, {
  3.796839906449986*^9, 3.7968399122432203`*^9}, {3.796878084050056*^9, 
  3.7968780845430813`*^9}},
 CellID->2018521702,ExpressionUUID->"a7b90d43-de58-4cb1-b252-e23f3021ff83"],

Cell[CellGroupData[{

Cell["Render 1", "Section",
 CellChangeTimes->{{3.7968397749819603`*^9, 3.796839782158141*^9}},
 CellID->1709422458,ExpressionUUID->"674a3d40-3d13-4976-bd2a-21910d13087e"],

Cell["\<\
The first way of rendering one model is to add all the selected pictures in \
one or combine every picture to one selected picture. The following are the \
options you can ask:

\[OpenCurlyDoubleQuote]imgs\[CloseCurlyDoubleQuote] \tto show all original \
images
\[OpenCurlyDoubleQuote]imgOneAll\[CloseCurlyDoubleQuote]\t to show all the \
overlay images on top of the selected one
\[OpenCurlyDoubleQuote]imgAll\[CloseCurlyDoubleQuote] \tto overlay all images \
on top of each other 

However, first, you have to specify the name of the folder where are the \
selected images then select specify the name of a selected image.\
\>", "Text",
 CellChangeTimes->{{3.796838379544407*^9, 3.796838395027563*^9}, {
   3.796838442773283*^9, 3.7968384430428677`*^9}, {3.796838722958637*^9, 
   3.796838793731388*^9}, {3.796838863404879*^9, 3.7968391576287947`*^9}, 
   3.7968393522735243`*^9, {3.796877907447999*^9, 3.79687791016113*^9}},
 CellID->1699091922,ExpressionUUID->"0ffc511d-5f44-43f3-9b0c-7bc1c60966f0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"selectedFolder", "=", "\"\<lake\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"selectedImgName", "=", "\"\<BosmTLVIMAADFT2\>\""}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.7968375721821613`*^9, 3.796837581069296*^9}, {
  3.7968782376850157`*^9, 3.796878261716902*^9}},
 Background->RGBColor[1, 1, 0.85],
 CellLabel->"In[3]:=",
 CellID->771636129,ExpressionUUID->"4f28e496-ed5d-44c0-b37b-7b78d625a22d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"img", "=", 
   RowBox[{"RenderModel1", "[", 
    RowBox[{"selectedFolder", ",", "selectedImgName"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.796837782155311*^9, 3.796837791188652*^9}, {
  3.796838357556861*^9, 3.796838365193205*^9}},
 Background->RGBColor[0.87, 0.94, 1],
 CellLabel->"In[9]:=",
 CellID->2057430712,ExpressionUUID->"7ac4de59-f45e-4867-b5cd-5d883b13741c"],

Cell[BoxData[
 RowBox[{"img", "[", "\"\<imgOneAll\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.796838368096086*^9, 3.796838410754644*^9}, 
   3.7968384528463593`*^9, {3.796838636077087*^9, 3.796838648260186*^9}, {
   3.796877839432279*^9, 3.796877891492505*^9}, 3.796877922096991*^9, 
   3.7968780065540113`*^9, 3.796878565932547*^9},
 CellID->1790296014,ExpressionUUID->"2a718c35-fa35-4440-994b-58441354f49c"]
}, Closed]],

Cell[CellGroupData[{

Cell["Render 2", "Section",
 CellChangeTimes->{{3.7968397749819603`*^9, 3.796839794239538*^9}},
 CellID->1264839107,ExpressionUUID->"c36077b0-7f9e-4e89-abc2-239f26827e2f"],

Cell["\<\
The second way of rendering is by creating a collage of all the selected \
images. To use this function first, you have to modify the name of all the \
selected images, for example, if you like one image you should rename it with \
a large number like 20, and the image that you prefer the least you will \
rename it with a lower number such as 1.

To use this function, you have to define the name of the folder where you \
have saved all the images and the color of the background, such as White.
\
\>", "Text",
 CellChangeTimes->{{3.7968394194765472`*^9, 3.796839732522848*^9}, 
   3.796839854850093*^9},
 CellID->1873927353,ExpressionUUID->"c5a827f8-8f72-4872-98d7-afbff2075f5d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"selectedFolder", "=", "\"\<geneva\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"background", "=", "White"}], ";"}]}], "Input",
 CellChangeTimes->{{3.7968397348089037`*^9, 3.796839740903905*^9}},
 Background->RGBColor[1, 1, 0.85],
 CellLabel->"In[38]:=",
 CellID->175299038,ExpressionUUID->"e6befffa-2b0a-4c76-851f-69e11684b1a8"],

Cell[BoxData[
 RowBox[{"RenderModel2", "[", 
  RowBox[{"selectedFolder", ",", "background"}], "]"}]], "Input",
 CellChangeTimes->{{3.796837920801509*^9, 3.7968379571502333`*^9}, {
   3.796838014866412*^9, 3.796838025358934*^9}, 3.796839746497909*^9},
 Background->RGBColor[0.87, 0.94, 1],
 CellLabel->"In[40]:=",
 CellID->1942943882,ExpressionUUID->"ac00530e-8882-4b9e-8772-b3dfc5af090e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"imgall", "=", 
   RowBox[{"RenderModel1", "[", 
    RowBox[{"selectedFolder", ",", "\"\<20\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.79687828821143*^9, 3.796878302716134*^9}, {
  3.796878545624013*^9, 3.796878548181234*^9}},
 Background->RGBColor[0.87, 0.94, 1],
 CellID->560183030,ExpressionUUID->"5803e56e-8f66-441c-ba9a-d17cdd3a76cf"],

Cell[BoxData[
 RowBox[{"imgall", "[", "\"\<imgAll\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7968783054636593`*^9, 3.796878313494219*^9}, 
   3.796878552544569*^9},
 CellID->1834176687,ExpressionUUID->"393306d7-f888-4588-9bd9-b1fcf35ca2e1"]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
Evaluator->"Local",
WindowSize->{1671, 857},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 187, 3, 48, "Chapter",ExpressionUUID->"e17d54d9-b671-4f0f-a60e-b794acba23c9",
 CellID->2121923006],
Cell[770, 27, 3516, 85, 433, "Code",ExpressionUUID->"30445314-8f63-4a39-ae4e-174de649c33b",
 CellID->1720803360],
Cell[4289, 114, 1929, 44, 186, "Code",ExpressionUUID->"6cd1e4bf-555a-4b2b-b98d-5c5a2ea95c97",
 CellID->81939663]
}, Closed]],
Cell[CellGroupData[{
Cell[6255, 163, 252, 3, 72, "Title",ExpressionUUID->"6c329363-bbb7-4566-a37f-03d97126da56",
 CellID->323882155],
Cell[CellGroupData[{
Cell[6532, 170, 267, 4, 69, "Chapter",ExpressionUUID->"a7b90d43-de58-4cb1-b252-e23f3021ff83",
 CellID->2018521702],
Cell[CellGroupData[{
Cell[6824, 178, 171, 2, 67, "Section",ExpressionUUID->"674a3d40-3d13-4976-bd2a-21910d13087e",
 CellID->1709422458],
Cell[6998, 182, 1013, 19, 173, "Text",ExpressionUUID->"0ffc511d-5f44-43f3-9b0c-7bc1c60966f0",
 CellID->1699091922],
Cell[8014, 203, 455, 11, 68, "Input",ExpressionUUID->"4f28e496-ed5d-44c0-b37b-7b78d625a22d",
 CellID->771636129],
Cell[8472, 216, 416, 10, 46, "Input",ExpressionUUID->"7ac4de59-f45e-4867-b5cd-5d883b13741c",
 CellID->2057430712],
Cell[8891, 228, 410, 6, 30, "Input",ExpressionUUID->"2a718c35-fa35-4440-994b-58441354f49c",
 CellID->1790296014]
}, Closed]],
Cell[CellGroupData[{
Cell[9338, 239, 171, 2, 53, "Section",ExpressionUUID->"c36077b0-7f9e-4e89-abc2-239f26827e2f",
 CellID->1264839107],
Cell[9512, 243, 693, 13, 127, "Text",ExpressionUUID->"c5a827f8-8f72-4872-98d7-afbff2075f5d",
 CellID->1873927353],
Cell[10208, 258, 381, 9, 68, "Input",ExpressionUUID->"e6befffa-2b0a-4c76-851f-69e11684b1a8",
 CellID->175299038],
Cell[10592, 269, 388, 7, 46, "Input",ExpressionUUID->"ac00530e-8882-4b9e-8772-b3dfc5af090e",
 CellID->1942943882],
Cell[10983, 278, 386, 8, 46, "Input",ExpressionUUID->"5803e56e-8f66-441c-ba9a-d17cdd3a76cf",
 CellID->560183030],
Cell[11372, 288, 242, 4, 30, "Input",ExpressionUUID->"393306d7-f888-4588-9bd9-b1fcf35ca2e1",
 CellID->1834176687]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

